std::vector<float> gaussianEliminationWithMaxElement(float** matrixorig, float* borig, int n) {
    float** matrix[n+10];
    float* b[n+10];
    matrix[0]=copyMatrix(matrixorig,n);
    b[0]=borig;
    std::pair<int, int> max;
    float m[n-1];
    float maxval;
    int iter=0;
    while (n!=1) {
        if (!iter){matrix[iter]=copyMatrix(matrixorig,n);b[iter]=copyMatrix(borig,n);}else
        matrix[iter]=copyMatrix(matrix[iter-1],n);
        max = MaxInArrayInArrayPos(matrix[iter], n);
        if (max.first != 0) {
            std::swap(*matrix[iter], matrix[iter][max.first]);
            std::swap(*b[iter], b[iter][max.first]);
        }
        maxval=matrix[iter][0][max.second];
    for (int i=1;i<n;i++)
        m[i-1]=-matrix[iter][i][max.second]/maxval;
    for (int i=1;i<n;i++){for (int k=0;k<n;k++)if (k!=max.second)
                matrix[iter][i][k]=matrix[iter][i][k]+matrix[iter][0][k]*m[i-1];b[iter][i]=b[iter][i]+b[iter][0]*m[i-1];}
    std::swap(matrix[iter][0],matrix[iter][n-1]);
    std::swap(*b,b[n-1]);
    for (int k=1;k<n-1;k++)for (int i=0;i<n;i++)if(i>max.second)matrix[iter][i-1]=matrix[iter][i];
    n--;iter++;
    display(matrix[iter],n,3,"Iterating...",b[iter]);}
    std::vector<float> res(n);
    res[0]=*b[iter]/matrix[0][0][0];
    res[1]=*b[iter]/matrix[0][0][0];
    return res;
}

std::pair<int,float> gaussianEliminationWithMaxElement(float** matrixorig, float* borig, int n) {
    float **matrix=copyMatrix(matrixorig,n);
    float b[n];
    for (int i=0;i<n;i++)b[i]=borig[i];
    bool notx[n];
    for (int i=0;i<n;i++)notx[i]=false;
    std::pair<int, int> max;
    float m[n-1];
    float maxval;
    while (n!=1) {
        max = MaxInArrayInArrayPos(matrix, n);
        notx[max.second]=true;
        if (max.first != 0) {
            std::swap(*matrix, matrix[max.first]);
            std::swap(*b, b[max.first]);
        }
        maxval=matrix[0][max.second];
    for (int i=1;i<n;i++)
        m[i-1]=-matrix[i][max.second]/maxval;
    for (int i=1;i<n;i++){for (int k=0;k<n;k++)if (k!=max.second)
                matrix[i][k]=matrix[i][k]+matrix[0][k]*m[i-1];b[i]=b[i]+b[0]*m[i-1];}
    std::swap(*matrix,matrix[n-1]);
    std::swap(*b,b[n-1]);
    for (int k=1;k<n-1;k++)for (int i=0;i<n;i++)if(i>max.second)matrix[i-1]=matrix[i];
    n--;
    display(matrix,n,3,"Iterating...",b);}
    std::pair<int,float> res;
    for (int i=0;i<n;i++)if(!notx[i]){res.first=i;break;}
    res.second=*b/matrix[0][0];
    return res;
}
std::pair<int, int> MaxInArrayInArrayPos(float** матриця, int розмір) {
    float макс_значення = матриця[0][0];
    int макс_рядок = 0;
    int макс_стовпець = 0;

    for (int рядок = 0; рядок < розмір; ++рядок) {
        for (int стовпець = 0; стовпець < розмір; ++стовпець) {
            if (std::abs(матриця[рядок][стовпець]) > std::abs(макс_значення)) {
                макс_значення = матриця[рядок][стовпець];
                макс_рядок = рядок;
                макс_стовпець = стовпець;
            }
        }
    }

    return std::make_pair(макс_рядок, макс_стовпець);
}
void luDecomposition(float** matrix, float** L, float** U, int size) {
    // Ініціалізуємо матриці L та U
    for (int i = 0; i < size; ++i) {
        for (int j = 0; j < size; ++j) {
            if (i == j) {
                L[i][j] = 1.0;
            } else {
                L[i][j] = 0.0;
            }
            U[i][j] = matrix[i][j];
        }
    }

    for (int i = 0; i < size; ++i) {
        for (int j = i; j < size; ++j) {
            float sum = 0.0;
            for (int k = 0; k < i; ++k) {
                sum += L[i][k] * U[k][j];
            }
            U[i][j] = matrix[i][j] - sum;
        }
        for (int j = i + 1; j < size; ++j) {
            float sum = 0.0;
            for (int k = 0; k < i; ++k) {
                sum += L[j][k] * U[k][i];
            }
            L[j][i] = (matrix[j][i] - sum) / U[i][i];
        }
    }
}
std::vector<float> backSubstitution(float** A, float* B, int n) {
    std::vector<float> solutions(n);

    for (int i = n-1; i >= 0; i--) {
        float sum = 0;
        for (int j = i + 1; j < n; j++)
            sum += A[i][j] * solutions[j];
        solutions[i] = (B[i] - sum) / A[i][i];
    }

    return solutions;
}
std::vector<float> solveLU(float** L, float** U, float* B, int n) {
    std::vector<float> y = backSubstitution(L, B, n);
    std::vector<float> x = backSubstitution(U, y.data(), n);
    return x;
}
